searchNodes=[{"doc":"The main interface for the system.","ref":"nuntius.html","title":"nuntius","type":"module"},{"doc":"Removes a mocking process.","ref":"nuntius.html#delete/1","title":"nuntius.delete/1","type":"function"},{"doc":"Removes an expect function. If the expect function was not already there, this function still returns 'ok'. If the process is not mocked, an error is returned.","ref":"nuntius.html#delete/2","title":"nuntius.delete/2","type":"function"},{"doc":"Adds a new expect function to a mocked process. When a message is received by the process, this function will be run on it. If the message doesn't match any clause, nothing will be done. If the process is not mocked, an error is returned. When the function is successfully added, a reference is returned as an identifier.","ref":"nuntius.html#expect/2","title":"nuntius.expect/2","type":"function"},{"doc":"Adds a new named expect function to a mocked process. When a message is received by the process, this function will be run on it. If the message doesn't match any clause, nothing will be done. If the process is not mocked, an error is returned. If there was already an expect function with that name, it's replaced. When the expect function is successfully added or replaced, it'll keep the name as its identifier.","ref":"nuntius.html#expect/3","title":"nuntius.expect/3","type":"function"},{"doc":"Returns the list of expect functions for a process.","ref":"nuntius.html#expects/1","title":"nuntius.expects/1","type":"function"},{"doc":"Returns the history of messages received by a mocked process.","ref":"nuntius.html#history/1","title":"nuntius.history/1","type":"function"},{"doc":"Returns the list of mocked processes.","ref":"nuntius.html#mocked/0","title":"nuntius.mocked/0","type":"function"},{"doc":"Returns the PID of the currently mocked process. Note : this code should only be used inside an expect fun.","ref":"nuntius.html#mocked_process/0","title":"nuntius.mocked_process/0","type":"function"},{"doc":"Returns the PID of a mocked process (the original one with that name).","ref":"nuntius.html#mocked_process/1","title":"nuntius.mocked_process/1","type":"function"},{"doc":"Equivalent to new(ProcessName, \#{}) . Injects a new mock process in front of the process with the provided name. Returns an error if there is no process registered under that name.","ref":"nuntius.html#new/1","title":"nuntius.new/1","type":"function"},{"doc":"Injects a new mock process in front of the process with the provided name. Options: passthrough : if true , all messages are passed through to the process by default. If false, messages that are not handled by any expectation are just dropped. default: true history : if true , the mocking process will keep the history of messages received. default: true","ref":"nuntius.html#new/2","title":"nuntius.new/2","type":"function"},{"doc":"Passes the current message down to the mocked process. Note : this code should only be used inside an expect fun.","ref":"nuntius.html#passthrough/0","title":"nuntius.passthrough/0","type":"function"},{"doc":"Passes a message down to the mocked process. Note : this code should only be used inside an expect fun.","ref":"nuntius.html#passthrough/1","title":"nuntius.passthrough/1","type":"function"},{"doc":"Returns whether a particular message was received already. Note : it only works with history =&gt; true.","ref":"nuntius.html#received/2","title":"nuntius.received/2","type":"function"},{"doc":"Erases the history for a mocked process.","ref":"nuntius.html#reset_history/1","title":"nuntius.reset_history/1","type":"function"},{"doc":"Equivalent to application:ensure_all_started(nuntius) . Starts the application.","ref":"nuntius.html#start/0","title":"nuntius.start/0","type":"function"},{"doc":"Stops the application.","ref":"nuntius.html#stop/0","title":"nuntius.stop/0","type":"function"},{"doc":"","ref":"nuntius.html#t:event/0","title":"nuntius.event/0","type":"type"},{"doc":"","ref":"nuntius.html#t:expect_fun/0","title":"nuntius.expect_fun/0","type":"type"},{"doc":"","ref":"nuntius.html#t:expect_id/0","title":"nuntius.expect_id/0","type":"type"},{"doc":"","ref":"nuntius.html#t:expect_name/0","title":"nuntius.expect_name/0","type":"type"},{"doc":"","ref":"nuntius.html#t:opts/0","title":"nuntius.opts/0","type":"type"},{"doc":"","ref":"nuntius.html#t:process_name/0","title":"nuntius.process_name/0","type":"type"},{"doc":"","ref":"nuntius_app.html","title":"nuntius_app","type":"module"},{"doc":"","ref":"nuntius_app.html#start/2","title":"nuntius_app.start/2","type":"function"},{"doc":"","ref":"nuntius_app.html#stop/1","title":"nuntius_app.stop/1","type":"function"},{"doc":"","ref":"nuntius_mocker.html","title":"nuntius_mocker","type":"module"},{"doc":"Reregisters the mocked process with its name, thus removing the mock.","ref":"nuntius_mocker.html#delete/1","title":"nuntius_mocker.delete/1","type":"function"},{"doc":"Removes an expect function.","ref":"nuntius_mocker.html#delete/2","title":"nuntius_mocker.delete/2","type":"function"},{"doc":"Adds a new expect function to a mocked process.","ref":"nuntius_mocker.html#expect/3","title":"nuntius_mocker.expect/3","type":"function"},{"doc":"Returns the list of expect functions for a process.","ref":"nuntius_mocker.html#expects/1","title":"nuntius_mocker.expects/1","type":"function"},{"doc":"Returns the history of messages received by a mocked process.","ref":"nuntius_mocker.html#history/1","title":"nuntius_mocker.history/1","type":"function"},{"doc":"","ref":"nuntius_mocker.html#init/3","title":"nuntius_mocker.init/3","type":"function"},{"doc":"Returns the PID of the currently mocked process.","ref":"nuntius_mocker.html#mocked_process/0","title":"nuntius_mocker.mocked_process/0","type":"function"},{"doc":"Returns the PID of a mocked process (the original one with that name).","ref":"nuntius_mocker.html#mocked_process/1","title":"nuntius_mocker.mocked_process/1","type":"function"},{"doc":"Passes the current message down to the mocked process.","ref":"nuntius_mocker.html#passthrough/0","title":"nuntius_mocker.passthrough/0","type":"function"},{"doc":"Passes a message down to the mocked process.","ref":"nuntius_mocker.html#passthrough/1","title":"nuntius_mocker.passthrough/1","type":"function"},{"doc":"Returns whether a particular message was received already.","ref":"nuntius_mocker.html#received/2","title":"nuntius_mocker.received/2","type":"function"},{"doc":"Erases the history for a mocked process. Note that there is no gen:cast(...), gen_server and others basically just send the message and move on, like us.","ref":"nuntius_mocker.html#reset_history/1","title":"nuntius_mocker.reset_history/1","type":"function"},{"doc":"Boots up a mocking process. If the process to be mocked doesn't exist, returns ignore .","ref":"nuntius_mocker.html#start_link/2","title":"nuntius_mocker.start_link/2","type":"function"},{"doc":"","ref":"nuntius_sup.html","title":"nuntius_sup","type":"module"},{"doc":"","ref":"nuntius_sup.html#init/1","title":"nuntius_sup.init/1","type":"function"},{"doc":"","ref":"nuntius_sup.html#mocked/0","title":"nuntius_sup.mocked/0","type":"function"},{"doc":"","ref":"nuntius_sup.html#start_link/0","title":"nuntius_sup.start_link/0","type":"function"},{"doc":"Starts a new mock process. See also: nuntius:new/2 .","ref":"nuntius_sup.html#start_mock/2","title":"nuntius_sup.start_mock/2","type":"function"},{"doc":"Terminates a mocking process. Reregisters the mocked process with its name.","ref":"nuntius_sup.html#stop_mock/1","title":"nuntius_sup.stop_mock/1","type":"function"},{"doc":"nuntius is an Erlang/OTP library to mock registered processes. Its main use case is to intercept messages sent to specific processes and to allow the consumer to act upon them.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"nuntius is best used via rebar3 's test profile and using Erlang/OTP's Common Test framework : 1. change your rebar.config to include: { profiles , [ { test , [ { deps , [ nuntius ] } ] } ] } . 2. run your nuntius -enabled tests with: rebar3 ct","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"places mock processes in front of previously registered processes; these mock processes will intercept (and optionally handle) every message that was supposed to go to the latter ones, then allows mock processes to decide on letting the messages pass through, or not, allows mock processes to run one or many pre-processing functions on each received message, allows mock processes to discard intercepted messages entirely, allows history collection of messages received by the mock processes for further analysis.","ref":"readme.html#features","title":"Overview - Features","type":"extras"},{"doc":"The following parameters allow you to configure the interaction between the mock and mocked processes, as well as other elements for debugging: passthrough : when true (default: true ) all messages received by the mock process are passed through to the mocked process, history : when true (default: true ) all messages received by the mock process are classified as per Understanding the message history .","ref":"readme.html#options-for-the-mock-process","title":"Overview - Options for the mock process","type":"extras"},{"doc":"History elements are classified with 4 keys: timestamp : an integer representing Erlang system time in native time unit, message : the message that was received and/or potentially handled by expectations (or passed through), mocked : an indication of whether or not any of the expecations you declared handled the message, passed_through : an indication of whether or not the received message was passed through to the mocked process.","ref":"readme.html#understanding-the-message-history","title":"Overview - Understanding the message history","type":"extras"},{"doc":"nuntius tries to execute your expectations by simply calling their declarations inside a try-catch expression. Because of this, non-matching expectations will return a function_clause , that is caught. Since it's not possible (at this moment) to distinguish a function_clause provoked by nuntius ' internal code or your own, we propose you to make sure your functions don't fail with a function_clause . You can also check the message history to understand if a given message was mocked and/or passed through.","ref":"readme.html#caveats","title":"Overview - Caveats","type":"extras"},{"doc":"Documentation is generated with: rebar3 edoc after which you can use your favorite Web browser to open doc/index.html . It is also available, online, at hexdocs.pm/nuntius .","ref":"readme.html#documentation","title":"Overview - Documentation","type":"extras"},{"doc":"Examples are found at examples .","ref":"readme.html#examples","title":"Overview - Examples","type":"extras"},{"doc":"This project adheres to Semantic Versioning .","ref":"readme.html#versioning","title":"Overview - Versioning","type":"extras"},{"doc":"We get inspiration for our README's format/content from Make a README .","ref":"readme.html#readme","title":"Overview - Readme","type":"extras"},{"doc":"All notable changes to this project will be referenced from the CHANGELOG .","ref":"readme.html#changelog","title":"Overview - Changelog","type":"extras"},{"doc":"Though this project is maintained by 2Latinos contributions are accepted and welcome. Check CONTRIBUTING.md for more.","ref":"readme.html#contributing","title":"Overview - Contributing","type":"extras"},{"doc":"Check LICENSE .","ref":"readme.html#license","title":"Overview - License","type":"extras"},{"doc":"License Reporting a bug Requesting or implementing a feature Submitting your changes Code Style Committing your changes Pull requests and branching Credits","ref":"contributing.html","title":"Contributing","type":"extras"},{"doc":"nuntius is licensed under The MIT License, for all code.","ref":"contributing.html#license","title":"Contributing - License","type":"extras"},{"doc":"nuntius is not perfect software and will be buggy. Bugs can be reported via GitHub issues: bug report . Some contributors and maintainers may be unpaid developers working on nuntius , in their own time, with limited resources. We ask for respect and understanding, and will provide the same back. If your contribution is an actual bug fix, we ask you to include tests that, not only show the issue is solved, but help prevent future regressions related to it.","ref":"contributing.html#reporting-a-bug","title":"Contributing - Reporting a bug","type":"extras"},{"doc":"Before requesting or implementing a new feature, do the following: search, in existing issues (open or closed), whether the feature might already be in the works, or has already been rejected, make sure you're using the latest software release (or even the latest code, if you're going for bleeding edge ). If this is done, open up a GitHub issues: feature request . We may discuss details with you regarding the implementation, and its inclusion within the project. We try to have as many of nuntius 's features tested as possible. Everything that a user can do, and is repeatable in any way, should be tested, to guarantee backwards compatible.","ref":"contributing.html#requesting-or-implementing-a-feature","title":"Contributing - Requesting or implementing a feature","type":"extras"},{"doc":"Code Style do not introduce trailing whitespace indentation is 4 spaces, not tabs try not to introduce lines longer than 100 characters write small functions whenever possible, and use descriptive names for functions and variables comment tricky or non-obvious decisions made to explain their rationale Committing your changes Merging to the main branch will usually be preceded by a squash. While it's Ok (and expected) your commit messages relate to why a given change was made, be aware that the final commit (the merge one) will be the issue title, so it's important it is as specific as possible. This will also help eventual automated changelog generation. Pull requests and branching All fixes to nuntius end up requiring a +1 from one or more of the project's maintainers. During the review process, you may be asked to correct or edit a few things before a final rebase to merge things. Do send edits as individual commits to allow for gradual and partial reviews to be done by reviewers. Credits nuntius has been improved by many contributors !","ref":"contributing.html#submitting-your-changes","title":"Contributing - Submitting your changes","type":"extras"},{"doc":"# License The MIT License (MIT) Copyright (c) 2022 Fernando Benavides Rodriguez and Paulo Ferraz de Oliveira Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"}]